# https://docs.nebula-graph.io/master/3.ngql-guide/1.nGQL-overview/keywords-and-reserved-words/

RESERVED_WORDS = {
    "ACROSS",
    "ADD",
    "ALTER",
    "AND",
    "AS",
    "ASC",
    "ASCENDING",
    "BALANCE",
    "BOOL",
    "BY",
    "CASE",
    "CHANGE",
    "COMPACT",
    "CREATE",
    "DATE",
    "DATETIME",
    "DELETE",
    "DESC",
    "DESCENDING",
    "DESCRIBE",
    "DISTINCT",
    "DOUBLE",
    "DOWNLOAD",
    "DROP",
    "DURATION",
    "EDGE",
    "EDGES",
    "EXISTS",
    "EXPLAIN",
    "FALSE",
    "FETCH",
    "FIND",
    "FIXED_STRING",
    "FLOAT",
    "FLUSH",
    "FROM",
    "GEOGRAPHY",
    "GET",
    "GO",
    "GRANT",
    "IF",
    "IGNORE_EXISTED_INDEX",
    # "IN",
    "INDEX",
    "INDEXES",
    "INGEST",
    "INSERT",
    "INT",
    "INT16",
    "INT32",
    "INT64",
    "INT8",
    "INTERSECT",
    # "IS",
    "JOIN",
    "LEFT",
    "LIST",
    "LOOKUP",
    "MAP",
    "MATCH",
    "MINUS",
    "NO",
    "NOT",
    "NULL",
    "OF",
    "ON",
    "OR",
    "ORDER",
    "OVER",
    "OVERWRITE",
    "PATH",
    "PROP",
    "REBUILD",
    "RECOVER",
    "REMOVE",
    "RESTART",
    "RETURN",
    "REVERSELY",
    "REVOKE",
    "SET",
    "SHOW",
    "STEP",
    "STEPS",
    "STOP",
    "STRING",
    "SUBMIT",
    "TAG",
    "TAGS",
    "TIME",
    "TIMESTAMP",
    "TO",
    "TRUE",
    "UNION",
    "UNWIND",
    "UPDATE",
    "UPSERT",
    "UPTO",
    "USE",
    "VERTEX",
    "VERTICES",
    "WHEN",
    "WHERE",
    "WITH",
    "XOR",
    "YIELD",
}

# https://github.com/vesoft-inc/nebula/blob/master/src/common/function/FunctionManager.cpp
FUNCTIONS = {
    "CONCAT",
    "CONCAT_WS",
    "COS_SIMILARITY",
    "COALESCE",
    "ABS",
    "BIT_AND",
    "BIT_OR",
    "BIT_XOR",
    "FLOOR",
    "CEIL",
    "ROUND",
    "SQRT",
    "CBRT",
    "HYPOT",
    "POW",
    "E",
    "EXP",
    "EXP2",
    "LOG",
    "LOG2",
    "LOG10",
    "PI",
    "RADIANS",
    "SIN",
    "COS",
    "ASIN",
    "ACOS",
    "TAN",
    "ATAN",
    "SIGN",
    "RAND",
    "RAND32",
    "RAND64",
    "NOW",
    "STRCASECMP",
    "LOWER",
    "TOLOWER",
    "UPPER",
    "TOUPPER",
    "LENGTH",
    "TRIM",
    "LTRIM",
    "RTRIM",
    "LEFT",
    "RIGHT",
    "REPLACE",
    "REVERSE",
    "SPACES",
    "SPLIT",
    "LPAD",
    "RPAD",
    "SUBSTR",
    "SUBSTRING",
    "TOSTRING",
    "TOBOOLEAN",
    "TOFLOAT",
    "TOINTEGER",
    "TOSET",
    "HASH",
    "SIZE",
    "TIME",
    "DATE",
    "DATETIME",
    "TIMESTAMP",
    "TAGS",
    "LABELS",
    "PROPERTIES",
    "TYPE",
    "TYPEID",
    "RANK",
    "STARTNODE",
    "ENDNODE",
    "KEYS",
    "NODES",
    "TAIL",
    "RELATIONSHIPS",
    "HEAD",
    "LAST",
    "RANGE",
    "HASSAMEEDGEINPATH",
    "HASSAMEVERTEXINPATH",
    "REVERSEPATH",
    "DATASETROWCOL",
    "ST_POINT",
    "ST_GEOGFROMTEXT",
    "ST_ASTEXT",
    "ST_CENTROID",
    "ST_ISVALID",
    "ST_INTERSECTS",
    "ST_COVERS",
    "ST_COVEREDBY",
    "ST_DWITHIN",
    "ST_DISTANCE",
    "S2_CELLIDFROMPOINT",
    "S2_COVERINGCELLIDS",
    "IS_EDGE",
    "DURATION",
    "EXTRACT",
    "JSON_EXTRACT",
    "SCORE",
}
